import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import WebFlow.QS.*;
import java.lang.reflect.*;
//import WebFlow.Util.*;
                               
public class mpGatewayPortal extends HttpServlet
{
  private ORB orb;
  private WebFlowContext ws = null;
  PrintWriter out;
  String[] SlaveServers;
  boolean slaveOn = false;
  String UserName;
  String Display;
  String challenge;
  private String cmd_line; 

  private String jroot;
  private String jhost,jport;
  private String jurl;
  private String relMasterIor;
  private String masterIOR;
  private String masterIORurl;
  private String iorDirectory; 
  public String  filename;
  public String  UserContext,host;
  public String  relUserConfigDir; 
  public String  userConfigDir; ///npac/home/webflow/WEBFLOW/BeanContext_2.1/QS/
  public String  ior = "hahaha";
  WebFlowContext uc=null;



  protected void doPost(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException
  {
    String temp[] = new String[1];
    UserName = req.getParameter("UserContext");
    Display=req.getParameter("DISPLAY");
    host=req.getParameter("HOST"); 
    challenge=req.getParameter("pw");
    System.out.println("User: "+UserName+ "aka "+challenge);

    /* Gateway Web server (gatekeeper) */ 
    jhost=req.getParameter("jhost");              
    jport=req.getParameter("jport");              
    jurl="http://"+jhost+":"+jport;   
    jroot=req.getParameter("jroot");             //WebServer's document root
    relMasterIor=req.getParameter("RelMasterIOR");  //master's IOR
    masterIOR=jroot+relMasterIor;
    masterIORurl=jurl+"/"+relMasterIor; 
    iorDirectory=jroot+req.getParameter("RelIorDir");  //modules' IORs
    relUserConfigDir=req.getParameter("UsrConfDir");
    //userConfigDir=jroot+relUserConfigDir;
    userConfigDir=relUserConfigDir;
    filename = jroot+"UserIOR.html";


    if(host.equals(jhost)) {
      cmd_line = 
    "xterm -sb -d "+Display+" -title "+UserName+" -e java WebFlow.Server "+userConfigDir+UserName+".conf";
    }
    else {

    cmd_line = 
    "xterm -d "+Display+" -title telnet -e java -cp .:/npac/home/webflow/WEBFLOW/JIGSAW/classes/jigsaw.zip:/npac/home/globus/akarsu/ORBacus/JOB-3.1.2/lib/OB.jar:/npac/home/webflow/WEBFLOW3/QS/kskim/Swing-1.1.1-beta1/swingall.jar:/npac/home/webflow/WEBFLOW/XML:/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/Gateway/WF:/npac/home/webflow/WEBFLOW/JSDK2.0/lib/jsdk.jar:/npac/home/webflow/WEBFLOW/Telnet/:/npac/home/webflow/WEBFLOW/WWW/MoveFileWebFlow.Server telnetcontainer "+UserName+" "+challenge;
    }    
      /*      
    "xterm -d "+Display+" -e java -cp .:/npac/home/webflow/WEBFLOW/JIGSAW/classes/jigsaw.zip:/npac/home/globus/akarsu/ORBacus/JOB-3.1.2/lib/OB.jar:/npac/home/webflow/WEBFLOW3/QS/kskim/Swing-1.1.1-beta1/swingall.jar:/npac/home/webflow/WEBFLOW/XML:/npac/home/webflow/WEBFLOW/JIGSAW/Jigsaw/WWW/Gateway/WF:/npac/home/webflow/WEBFLOW/JSDK2.0/lib/jsdk.jar:/npac/home/webflow/WEBFLOW/Telnet/:/npac/home/webflow/WEBFLOW/WWW/MoveFileWebFlow.Server WebFlow.Server "+userConfigDir+UserName+".conf";
    */

    temp[0] = "";
    res.setContentType("text/html");
    out = res.getWriter();                                                   

    
    /* connect to the master server */

    String MasterRef = ReadSTRFromFile(masterIOR);
    
    if(pingServer(MasterRef)) {
      System.out.println("master contacted");

      /* check whether the slave already exists */
    slaveOn=false; 

    /* BeanContext 2.1 */
    /*
    SlaveServers=ws.getAllWFServers();
    for(int i=0; i<SlaveServers.length; i++) {
      System.out.println(SlaveServers[i]);
      if(SlaveServers[i].indexOf(UserName)>-1) slaveOn=true;
    }
    */
    /* BeanContext 2.2 */
    System.out.println("look for slave...");
    org.omg.CORBA.Object[] SlaveServers2=ws.toArray();
    System.out.println("slaves? "+SlaveServers2.length);
    for(int i=0; i<SlaveServers2.length; i++) {    
           System.out.println("..."+i);
           WebFlowContext sl=WebFlowContextHelper.narrow(SlaveServers2[i]);
           System.out.println("... got sl");
           String SlaveName = sl.getObjectID();
	   System.out.println(SlaveName);
           if(SlaveName.indexOf(UserName)>-1) slaveOn=true;
    }
    /* end of BeanContext 2.2 */
    if(slaveOn) {
      System.out.println("The user context is available...");
    }
    else {
      System.out.println("Start a new user context");
      File oldFile = new File(iorDirectory+UserName+".FileBrowser.txt");
      if(oldFile.exists()) {
	System.out.println("oldFile deleted: "+oldFile.delete());
      }   
      File oldFile1 = new File(iorDirectory+UserName+"xmlServer.txt");
      if(oldFile1.exists()) {
	System.out.println("oldFile deleted: "+oldFile1.delete());
      }   
      File oldFile2=new File(iorDirectory+UserName+"xmlServer.txt");
      if(oldFile1.exists()) {
	System.out.println("oldFile deleted: "+oldFile1.delete());
      }

   System.out.println("create a new slave"); 

     /* generate a new config file */

   /*   System.out.println("UserName = "+UserName);
      System.out.println("file1: "+ userConfigDir+UserName+".conf");
      System.out.println("file2: "+ userConfigDir+"nobody.conf");
      CopyFile(userConfigDir+UserName+".conf",userConfigDir+"nobody.conf");
      RandomAccessFile randfile = 
        new RandomAccessFile(userConfigDir+UserName+".conf","rw");
      randfile.writeBytes("ServerName="+UserName+".      "); 
   */

   int iError=createSlaveConf(userConfigDir+UserName+".conf");

   try {
     Process p = Runtime.getRuntime().exec(cmd_line);        
    } 
     catch (Exception ex) {
     System.err.println("Error in starting WebFlowServer :"+ex);
    }
     /* wait till the server is up */
    org.omg.CORBA.Object[] SlaveServers1;
    String[] SlaveServers;
  
    for (int j=0; j<100; j++) {
    SlaveServers1=ws.toArray(); 
    /*     BeanContext_2.1
       SlaveServers=ws.getAllWFServers();
       for(int i=0; i<SlaveServers.length; i++) {
           System.out.println(SlaveServers[i]);
	   if(SlaveServers[i].indexOf(UserName)>-1) slaveOn=true;
           if(slaveOn) break;
           waitForServer(500);
       } 
       */    
 
    /*    BeanContext_2.2 */
       System.out.println("How many slaves? "+SlaveServers1.length);
       if(SlaveServers1.length<1) {
          waitForServer(50000);
       } else {
       for(int i=0; i<SlaveServers1.length; i++) {
           //System.out.println(SlaveServers1[i].toString());
	   //   if((SlaveServers1[i].toString()).length()<1) {
           //   System.out.println(" no slave servers!");
           //   continue;
	   //}
           WebFlowContext sl=WebFlowContextHelper.narrow(SlaveServers1[i]);
   
	   String SlaveName = sl.getObjectID();
	   System.out.println(SlaveName);
           if(SlaveName.indexOf(UserName)>-1) slaveOn=true;
           if(slaveOn) break;
           waitForServer(500);
       }     
       }
    }

    }
    
    if(slaveOn) {
      System.out.println("slave is on");
      uc=null;
      try {
      String serverName=UserName+".";
      System.out.println("connect to server "+serverName);
      /* change in ver 2.2 !!! */
      org.omg.CORBA.Object ucobj=ws.getContext(jhost+"/"+serverName);
      System.out.println("got ucobj");
      if(ucobj==null) System.out.println("ucobj is null");
        uc=WebFlowContextHelper.narrow(ucobj);
      } catch (Exception e7) {
          uc=null; 
          System.out.println("got exception: cannot get the user context");
          System.out.println(e7);
      }
      if(uc!=null) { 
      System.out.println("user context is OK");

	/* add services */

      //Add FileBrowser
      FileBrowser fb=(WebFlow.QS.FileBrowser)addService("FileBrowser","FileBrowser");
      System.out.println("FileBrowser added");
      try {
	fb.test();
      } catch (Exception e2) {System.out.println(e2);}    

      //Add XMLFileBrowser      
      FileBrowser xfb=(WebFlow.QS.FileBrowser)addService("FileBrowser","XMLFileBrowser");
      System.out.println("XMLFileBrowser added");
      try {
	xfb.test();
      } catch (Exception e2) {System.out.println(e2);}    
      
      
      //Add RemoteFile
      RemoteFile rf=(WebFlow.QS.RemoteFile)addService("RemoteFile","RemoteFile");
      System.out.println("RemoteFile added");
      try {
	rf.test();
      } catch (Exception e2) {System.out.println(e2);}    
      
      //Add SimpleJob
      SimpleJob sj=(WebFlow.QS.SimpleJob)addService("SimpleJob","SimpleJob");
      System.out.println("SimpleJob added");
      try{
	sj.test();
      }catch(Exception e) {System.out.println(e);}

      //Add Ising
      Ising is=(WebFlow.QS.Ising)addService("Ising","Ising");
      System.out.println("Ising added");
      try{
	is.test();
      }catch(Exception e) {System.out.println(e);}


    System.out.println("slave completed successfully, return the applet");
    res.setContentType("text/html");
    out.println("<html>");
    out.println("<frameset COLS=\"70%,*\">");
    out.println("  <frame NAME=\"GatewayHTML\" SRC=/servlets/UserPage?userContext="+UserName+">");
    out.println("  <frame NAME=\"GatewayApplet\" SRC=/servlets/mpGateway?userContext="+UserName+">");
    out.println("</frameset>");
    out.println("</html>");
    System.out.println("about to flush");
    out.flush();
    System.out.println("frameset completed");
    out.close();

      }
      else {
       out.println("Sorry, connot connect to your context");
      }
    } 
    else {
      System.out.println("slave is not responding!");
      out.println("Sorry, cannot access your context");
    }
    }
    else {
      System.out.println("master is not responding!");
      out.println("Sorry, the WebFlow system is down!");
    }
 //out.close(); 
}

  org.omg.CORBA.Object resolveWFServer(ORB orb)
                     throws Exception
  {
    WebFlowContext root_ctx;
    String ref;

    java.net.URL url = new java.net.URL(masterIORurl);
    InputStream istream;
    try {
      istream = url.openStream();
  		BufferedReader in = new BufferedReader(new InputStreamReader(istream));
  		ref = in.readLine();
  		istream.close();
      }
    catch(IOException e) {
      error("Can't open URL: " + url);
      throw new Exception("Can't open URL: " + url);
      }

    org.omg.CORBA.Object obj = orb.string_to_object(ref);
    if(obj == null)
  		throw new RuntimeException();
    root_ctx = WebFlowContextHelper.narrow(obj);
    if(root_ctx == null)
      throw new RuntimeException();
// get uc_1 from the portal page and make a context with that.

    return root_ctx.addNewContext(UserName);
  }
  
  private void save(String data) throws IOException
  {
 //   StringOutputStream output =
  //    new StringOutputStream(new FileOutputStream(filename));
    	FileOutputStream foutput = 
                   new FileOutputStream(filename);
    
    foutput.write(data.getBytes());
    
    foutput.close();
  }
 
  void error(String msg)
  {
    //out.println(msg);
  }

  void status(String msg)
  {
    //out.println(msg);
  }
                              
  public String getServletInfo()
  {
  return "By Praveen";
  }

  public boolean pingServer (String MasterRef)
  {   
    System.out.println("Pinging the server");
    if (MasterRef.equals("")) { 
     System.out.println("Cannot read reference from the file\n" +  masterIOR);
     return false;
    } 
    else
    { 
      ws=Str2Obj(MasterRef);  
      if (ws == null) {
         System.out.println("Cannot Connect to Object");
         return false;
      }
      else
      {
	boolean non_exist = true;
	try{
	    non_exist = ws._non_existent();
	}
        catch(org.omg.CORBA.COMM_FAILURE ex){}
	catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

        return !non_exist;

    }  //else
  }  //pingServer
  }
    public synchronized void waitForServer(long delay){
        System.err.println("waiting...");
        try {
           wait(delay);
        } catch(InterruptedException e){
                 System.out.println("Intrrupted exc :"+e);
        }
    }

  public String ReadSTRFromFile(String masterIOR) 
       //          throws FileNotFoundException, IOException
  {
      //open a file
      FileInputStream theFile;
      BufferedReader fileReader;
      String sObjRef;

      try {
           theFile=new FileInputStream(masterIOR);
           fileReader=new BufferedReader(new InputStreamReader(theFile));
      }
      catch(FileNotFoundException e){
           return "";
      }

      //read a reference string
      try {
        sObjRef=fileReader.readLine();
        System.err.println("Got the reference: "+sObjRef);
      }
      catch (IOException e) {
        return "";
      }
      
      try {
        theFile.close();
        fileReader.close();
      }
      catch (IOException e) {}

      //return the reference string
      return sObjRef;
  }

  protected  WebFlowContext Str2Obj(String sObjRef)
  {
    String[] args = new String[1];
    args[0] = new String("");

    orb = ORB.init(args, new java.util.Properties());
    if(orb == null)
    {
      System.err.println("ORB connecting error");
      return null ; //"ORB connecting error";
    }
    else
    {
      System.err.println("ORB is created successfully");
      org.omg.CORBA.Object obj = orb.string_to_object(sObjRef); ;
      return  WebFlowContextHelper.narrow(obj);
    }
  }

  public void CopyFile(String outfilename,String infilename)
  {

   try{
      File inputFile = new File(infilename);
      File outputFile = new File(outfilename);
      FileReader in1 = new FileReader(inputFile);
      FileWriter out1 = new FileWriter(outputFile);
      int c;
      while ((c = in1.read()) != -1){
             out1.write(c);
      }
      in1.close();
      out1.close();
   }
   catch (IOException e){
       System.err.println("copying the file: "+e);
   }

  }      

  int createSlaveConf(String fname) {
    int result=0;
    String idlFile="/npac/home/webflow/WEBFLOW/BeanContext_2.2/QS/qs.idl";
    try {
    FileWriter fw = new FileWriter(fname);
    fw.write("ServerName="+UserName+".\n");
    fw.write("File=none\n");
    fw.write("URL="+masterIORurl+"\n");
    fw.write("PARENT="+jhost+"\n");
    fw.write("Modules:===================\n");
    fw.write("FileBrowser "+idlFile+" WebFlow.QS.FileBrowserImp\n");
    fw.write("EditFile "+idlFile+" WebFlow.QS.EditFileImp\n");
    fw.write("SaveAs "+idlFile+" WebFlow.QS.SaveAsImp\n");
    fw.write("PBS "+idlFile+" WebFlow.QS.PBSimp\n");
    fw.write("GLOBUS "+idlFile+" WebFlow.QS.GLOBUSImp\n");
    fw.write("xmlServer "+idlFile+" WebFlow.QS.xmlServerImp\n");
    fw.write("RemoteFile "+idlFile+" WebFlow.QS.RemoteFileImp\n");
    fw.write("SimpleJob "+idlFile+" WebFlow.QS.SimpleJobImp\n");
    fw.write("Ising "+idlFile+" WebFlow.QS.IsingImp\n");
    fw.flush();
    fw.close();
    } catch(IOException ioe) {
        System.out.println(ioe);
        result=5;
    }
    return result;
  }

  org.omg.CORBA.Object addService(String ServiceName, String IORName){
   
      WebFlow.BeanContextChild Service=null;
      org.omg.CORBA.Object ServiceObj=null;
      org.omg.CORBA.Object ServiceObj_old=null;
      boolean ServiceExists = false;

      /* load ServiceHelper class */

      String HelperName = "WebFlow.QS."+ServiceName+"Helper";
      Class Helper = null;
      try {
           Helper = Class.forName(HelperName);
      } catch (ClassNotFoundException cnfe) {
               System.out.println("Can't load "+HelperName);
	     }
      System.out.println("class "+HelperName+" loaded!");

      /* find narrow method */
      Method[] allMethods = Helper.getMethods();
      Class argList[]=null;
      int nmeth = allMethods.length; 
      int nmindx = 0; 
      for(int i=0;i<nmeth;i++) {
         if((allMethods[i].getName()).equals("narrow")) {
              nmindx = i;
              argList = allMethods[i].getParameterTypes();
	 } 
      }
      Method narrow = null;
      try {
         narrow = Helper.getMethod("narrow",argList);
      } catch (NoSuchMethodException nsme) {
         System.out.println("No <<narrow>> method in "+HelperName);
      }  

      System.out.println("method narrow found ...");


      /* IOR exists? */
      String iorFileName = iorDirectory+UserName+"."+IORName+".txt";
      System.out.println("ior file: "+iorFileName);
      File iorFile = new File(iorFileName);
      System.out.println("file object created");
      boolean q = iorFile.exists();
      System.out.println(iorFileName+" exists? "+q);
      if(iorFile.exists()) {
	  /* read IOR */
          System.out.println("file "+iorFileName+" exists");
          String ServiceRef = ReadSTRFromFile(iorFileName);
          System.out.println("returned fromReadSTRFromFile");
          /* convert IOR to CORBA object */
          try {
          ServiceObj_old=orb.string_to_object(ServiceRef);
          }
          catch (Exception e1) {System.out.println("the ior is useless");
                                ServiceExists=false;} 
          System.out.println("returned from string_to_object");

          if(ServiceObj_old == null) {
             System.out.println("ServiceObj_old is null");
             ServiceExists=false;
	  }  
          if(ServiceObj_old != null) {
             /* apply the narrow method to the service object */
             java.lang.Object[] MethodArg = new java.lang.Object[1];
             MethodArg[0]=ServiceObj_old;
             try {
             Service =(WebFlow.BeanContextChild)narrow.invoke(Helper,MethodArg);
             System.out.println("returned from invoke...");
 	     }
             catch (Exception e) {
               Throwable t;
               if(e instanceof InvocationTargetException)
                t = ((InvocationTargetException) e).getTargetException();
               else t=e;
               System.out.println("narrow exited with exception " + t);
               t.printStackTrace();
	     }      
             System.out.println("returned narrow");
	     /* connect to the Service */
             if(Service != null) {
                ServiceExists = true;
        	try {
         System.out.println(ServiceName+": WFserver? "+Service.isWFServer());
	        //Service.test();
                } catch (Exception e2) {ServiceExists=false;}
	     }
	  }
          if(!ServiceExists) {
	    /* delete the obsolete IOR */ 
	     boolean x = iorFile.delete();
             System.out.println("ior deleted - "+x);
	  } 
      }
      else {
        System.out.println("iorFile does not exist");
        ServiceExists = false;
      }   

      if(ServiceExists) {
	/* this is not needed, I guess */
          System.out.println(ServiceName+" exists");
         ServiceObj = ServiceObj_old;
      }
      else {
        /* Service does not exist: create it from scratch */
        System.out.println(ServiceName+" does not exist");
        ServiceObj=uc.addNewModule(ServiceName);
        if(ServiceObj==null) System.out.println("Oops, file browser not found!");
        System.out.println("writting IOR to "+iorFileName);
        try {
         FileWriter fwriter = new FileWriter(iorFileName);
         System.out.println("fwriter created"); 
         if(ServiceObj==null) System.out.println("Oops, file browser not found!");
         if(orb==null) System.out.println("Oops, no orb!");
         String mior = orb.object_to_string(ServiceObj);
         System.out.println("new IOR = "+mior); 
         fwriter.write(mior);
         fwriter.flush();
         fwriter.close();
         System.out.println(iorDirectory+UserName+"."+ServiceName+".txt written");
	} catch (Exception eee){System.out.println(eee+" IORwriter exception");
	}
        /* narrow and test the service */
             
             /* apply the narrow method to the service object */
             java.lang.Object[] MethodArg = new java.lang.Object[1];
             MethodArg[0]=ServiceObj;
             try {
             Service =(WebFlow.BeanContextChild)narrow.invoke(Helper,MethodArg);
             System.out.println("returned from invoke...");
 	     }
             catch (Exception e) {
               Throwable t;
               if(e instanceof InvocationTargetException)
                t = ((InvocationTargetException) e).getTargetException();
               else t=e;
               System.out.println("narrow exited with exception " + t);
               t.printStackTrace();
	     }      
             System.out.println("returned narrow");
	     /* connect to the Service */
             if(Service != null) {
                ServiceExists = true;
        	try {
         System.out.println(ServiceName+": WFserver? "+Service.isWFServer());
                } catch (Exception e2) {ServiceExists=false;
                  System.out.println(e2.toString());}
	     }
             else {System.out.println("Oops: "+ServiceName+" is null");}
      }
    return Service;
  }  
  

}




